//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen

//
//
//
//
//

extern int                CCIPeriod         = 50;
extern ENUM_APPLIED_PRICE CCIPrice          = PRICE_TYPICAL;
extern double             LevelUp           = 100;
extern double             LevelDown         = -100;
extern bool               alertsOn          = true;
extern bool               alertsOnZoneEnter = true;
extern bool               alertsOnZoneExit  = true;
extern bool               alertsOnCurrent   = false;
extern bool               alertsMessage     = true;
extern bool               alertsSound       = true;
extern bool               alertsNotify      = false;
extern bool               alertsEmail       = false;
extern string             soundFile         = "alert2.wav";
//
//
//
//
//

double cci[];
double prices[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,cci);
      SetIndexBuffer(1,prices);
      SetIndexBuffer(2,trend);
      SetLevelValue(0,LevelUp);
      SetLevelValue(1,LevelDown);
   IndicatorShortName(" CCI ("+CCIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i);
      double avg = 0; for(k=0; k<CCIPeriod; k++) avg +=         prices[i+k];      avg /= CCIPeriod;
      double dev = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIPeriod;
          if (dev!=0)
                cci[i] = (prices[i]-avg)/(0.015*dev);
          else  cci[i] = 0;
          
          //
          //
          //
          //
          //
          
          trend[i] = trend[i+1];
            if (cci[i]>LevelUp)                     trend[i]= 1;
            if (cci[i]<LevelDown)                   trend[i]=-1;
            if (cci[i]<LevelUp && cci[i]>LevelDown) trend[i]= 0;
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         if (alertsOnCurrent)
             int whichBar = 0;
         else     whichBar = 1; 
         if (trend[whichBar] != trend[whichBar+1])
         {
           if (alertsOnZoneEnter && trend[whichBar]   ==  1) doAlert(whichBar,DoubleToStr(LevelUp,2)  +" broken up");
           if (alertsOnZoneEnter && trend[whichBar]   == -1) doAlert(whichBar,DoubleToStr(LevelDown,2)+" broken down");
           if (alertsOnZoneExit  && trend[whichBar+1] == -1) doAlert(whichBar,DoubleToStr(LevelDown,2)+" broken up");
           if (alertsOnZoneExit  && trend[whichBar+1] ==  1) doAlert(whichBar,DoubleToStr(LevelUp,2)  +" broken down");
         }
       }
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

        message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," cci level ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," cci  "),message);
             if (alertsSound)   PlaySound(soundFile);
   }
}


   